#!/usr/bin/python
# -*- coding: euc-jp -*-
import sys, os
import string, re

import Expr, Scan, Value

VALUE_STRING = '\xfe@S\xff'
LINE_STRING = '\xfe@d\xff'		# ִֹΥޡ
ASSERT_STRING = 'if ((expr)==false) throw new Error(__FILE__+"("+__LINE__+"): assert stop")'
TRACE_STRING = 'System.out.println(str)'

# #define()Ф
expr_func_re = re.compile( r'(.*)\((.*)\)', re.I )
define_check_re = re.compile( r'\s*\((.+)\)', re.I )
#
# Ԥ define ִ
#
def replace_line(g, filename=None, line=None):
	l = len(g)
	i = 0
	rstr = []
	while i < l:
		str = g[i]
		if Value.def_list.has_key(str):
			# ִʸ󤬤ä
			(v, exp, lflags, flags) = Value.def_list[str]
			if lflags and line:
				v = v.replace( LINE_STRING, '"%d"' % line )
			if exp:
				# VALUE_STRING Τִ
				# () Ȥõ
				gm = define_check_re.match( ''.join(g[i+1:]) )
				if gm:
					s = gm.group(1)
					s = s.lstrip()
					s = s.rstrip()
					# ̤Ȥִ
					ss = Scan.scan(s)
					ns = replace_line( ss, filename, line )
					s = ''.join(ns)
					s = s.lstrip()
					s = s.rstrip()
					if v:
						str = v.replace( VALUE_STRING, s )
					# äνޤǿʤ
					while g[i] != ')':
						i = i + 1
					i = i + 1
					rstr.append(str)
				else:
					# ִǤʤ
					rstr.append(str)
					i = i + 1
			else:
				s = v.lstrip()
				s = s.rstrip()
				rstr.append(s)
				i = i + 1
		else:
			# ٤Ĥˤʤʤ
			rstr.append(str)
			i = i + 1

	return rstr

#
# define ɲä
#  key=value , flags  true λ global 
#  expr_func  true λVALUE_STRING ¸ߤ
#  line_replace  true λLINE_STRING ¸ߤ
#
def add_symbol(key, value, flags=False):
	if Value.def_list.has_key(key):
		print '%s ϤǤƤޤ' % key
		return 1

	if (not flags) and Value.include_flag:
		flags = True

	expr_func = False
	line_place = False
	if value:
		# value ͤñ줴Ȥʬ
		vg = Scan.scan(value)

		# key () ǳƤ顢򳰤
		g = expr_func_re.match( key )
		if g:
			key = g.group(1)
			v = g.group(2)
			# v ͤ VALUE_STRING ִ
			nvg = []
			for str in vg:
				if str == v:
					nvg.append( VALUE_STRING )
				else:
					nvg.append( str )
			vg = nvg
			expr_func = True
		# Ȥä
		# __LINE__ ä LINE_STRING ִ
		for i in range(len(vg) - 1, -1, -1): # for(i=len(vg)-1; i>-1; i--)
			if (not vg[i]) or len(vg[i]) < 2:
				continue
			if vg[i] == '__LINE__':
				vg[i] = LINE_STRING
				line_place = True
			if vg[i][0:2] == '/*' and vg[i][-2:] == '*/':
				del vg[i]
			if vg[i][0:2] == '//':
				del vg[i]

		# ϿƤ define 󤬤ä
		# ִƤޤ
		ovg = replace_line(vg)

		Value.def_list[key] = (''.join(ovg), expr_func, line_place, flags)
	else:
		# key  () ä礽Ϥ
		g = expr_func_re.match( key )
		if g:
			key = g.group(1)
			expr_func = True
		Value.def_list[key] = (None, expr_func, line_place, flags)

	return 0

#
# local Ƥ륷ܥ
#
def del_local_symbol():
	for k in Value.def_list.keys():
		(v, expr_func, lflags, flags) = Value.def_list[k]
		if not flags:
			del Value.def_list[k]

#
# 顼ɽ
#
def put_error(msg, filename, line):
	if filename and line:
		print '%s(%d): %s' % (filename, line, msg)
	else:
		print '%s' % msg

def pass_space(g, start_pos=0, end_pos=0):
	index = start_pos

	while g[index].isspace():
		index = index + 1
		if end_pos != 0 and index >= end_pos:
			return end_pos

	return index

# ץץåǻȤ顼
class Error(Exception):
	def __init__(self, msg=""):
		Exception.__init__(self, msg)

# #define func(expr) expr
def do_DEFINE(lstr):
	if Value.comment_flag and (not Value.comment_flag[-1]):
		return
	# key  value Ф
	end_pos = len(lstr)

	# ǽζȤФ
	i = pass_space( lstr )

	key = lstr[i]
	i = i + 1

	# key ˰꤬뤫ɤĴ٤
	check_string = ''.join(lstr[i:])
	g = define_check_re.match(check_string)
	if g:
		# key ˰äƤ
		s = g.group(1)
		s = s.lstrip()	# ζä
		s = s.rstrip()	# ζä
		key = key + s
		while lstr[i] != ')':
			i = i + 1
		i = i + 1

	# value õ
	if i < end_pos:
		i = pass_space( lstr, i, end_pos )
	value = None
	if i != end_pos:
		value = ''.join(lstr[i:])
		value = value.rstrip();

	add_symbol( key, value )

# #undef func
def do_UNDEF(lstr):
	if Value.comment_flag and (not Value.comment_flag[-1]):
		return
	i = pass_space(lstr)
	key = ''.join(lstr[i:])
	key = key.rstrip()

	if Value.def_list.has_key(key):
		del Value.def_list[key]

# #ifdef define_string
def do_IFDEF(lstr):
	i = pass_space(lstr)
	str = ''.join(lstr[i:])
	str = str.rstrip()

	if Value.def_list.has_key(str):
		Value.comment_flag.append( True )
	else:
		Value.comment_flag.append( False )

# #ifndef define_string
def do_IFNDEF(lstr):
	i = pass_space(lstr)
	str = ''.join(lstr[i:])
	str = str.rstrip()

	if Value.def_list.has_key(str):
		Value.comment_flag.append( False )
	else:
		Value.comment_flag.append( True )

# #if expr
def do_IF(lstr):
	if Expr.expr(lstr):
		Value.comment_flag.append( True )
	else:
		Value.comment_flag.append( False )

# #else
def do_ELSE(lstr):
	# ǸΥե饰ȿž
	flag = not Value.comment_flag[-1]
	Value.comment_flag = Value.comment_flag[:-1]
	Value.comment_flag.append( flag )

# #elif epxr
def do_ELIF(lstr):
	flag = Expr.expr(lstr)
	last_flag = Value.comment_flag[-1]
	Value.comment_flag = Value.comment_flag[:-1]

	if flag and (not last_flag):
		# ǸΥե饰 true ˤ
		Value.comment_flag.append( True )
	else:
		# ǸΥե饰 false ˤ
		Value.comment_flag.append( False )

# #endif
def do_ENDIF(lstr):
	if len(Value.comment_flag) <= 0:
		raise Error, "#endifбäƤޤ"

	Value.comment_flag = Value.comment_flag[:-1]

# #include
def do_INCLUDE(lstr):
	if Value.comment_flag and Value.comment_flag[-1]:
		return

	filename = None
	for f in lstr:
		if (not f) or f[0] != '"':
			continue
		if f[-1] != '"':
			raise Error, "#include λ꤬ѤǤ"
		filename = f[1:-1]
		break

	if not filename:
		raise Error, "#include Υե̾ꤵƤޤ"

	if Value.include_path:
		fullpath = os.path.join( Value.include_path, filename )
	else:
		fullpath = filename
	parse( fullpath )

#
# ץץåν
#
def pre_process(lstr, f, l):
	assert lstr
	assert len(lstr) > 0

	p = lstr[0][1:]

	func_list = globals()
	func_name = 'do_' + p.upper()
	if func_list.has_key( func_name ):
		try:
			func_list[ func_name ]( lstr[1:] )
			return 0
		except IndexError:
			# 󳰻Ȥޤ
			put_error( 'ץץåηѤǤ: %s' % (''.join(lstr)), f, l )
		except Expr.Error, msg:
			# η׻ǥ顼
			put_error( 'βϥ顼(%s)' % msg, f, l )
		except Error, msg:
			# ץץåϤΥ顼
			put_error( 'ץץå顼(%s)' % msg, f, l )
		return 1
	else:
		put_error( 'ץץå "%s" ϻȤޤ' % ''.join(lstr), f, l )
		return 1

#
# ʸ
#
def parse(filename, putname = None):
	# debug ⡼ɤɤȽ
	Value.debug = False
	if Value.def_list.has_key('_DEBUG'):
		Value.debug = True

	Value.comment_flag = []

	# ǥХåѤüɲ
	if Value.debug:
		if filename:
			add_symbol( '__FILE__', '"%s"' % string.replace(filename, "\\", "\\\\") )
		else:
			add_symbol( '__FILE__', '""' )
		add_symbol( 'ASSERT(expr)', ASSERT_STRING )
		add_symbol( 'TRACE(str)', TRACE_STRING )
	else:
		add_symbol( '__FILE__', '""' )
		add_symbol( 'ASSERT(expr)', '{ /* */ }' )
		add_symbol( 'TRACE(str)', '{ /* */ }' )
	add_symbol( '__LINE__', '__LINE__' )

	try:
		fp = open( filename, 'r' )
	except IOError, e:
		print '%s 򳫤ȤǤޤ: %s' % (filename, e)
		return 1

	if putname:
		try:
			op = open( putname, 'w' )
		except IOError, e:
			print '%s 򳫤ȤǤޤ: %s' % (putname, e)
			return 1
	else:
		op = None

	err = 0
	line = 0
	crlf = '\r\n'
	for l in fp.readlines():
		line = line + 1
		if len(l) >= 2 and l[-2:] == '\r\n':
			l = l[:-2]
			crlf = '\r\n'
		elif len(l) >= 1 and l[-1] == '\n':
			l = l[:-1]
			crlf = '\n'

		g = Scan.scan(l)

		omsg = ''
		if (not g) or len(g) < 1:
			# ʤ
			omsg = crlf
		elif g[0][0] == '#':
			# ץץå
			err = err + pre_process( g, filename, line )
			if Value.pre_comment:
				omsg = '//' + l + crlf
			else:
				omsg = crlf
		else:
			# ̤ι
			if Value.comment_flag and (not Value.comment_flag[-1]):
				if Value.pre_comment:
					# Ȥˤƽ
					omsg = '//' + l + crlf
				else:
					omsg = crlf
			else:
				# ִ
				ng = replace_line(g, filename, line)
				omsg = ''.join(ng) + crlf
		if op:
			op.write( omsg )

	return err
